/*
 * Copyright Bigeon Emmanuel (2014)
 *
 * emmanuel@bigeon.fr
 *
 * This software is a computer program whose purpose is to
 * provide a generic framework for console applications.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */
/**
 * gclc:fr.bigeon.gclc.tools.AOutputForwardRunnableTest.java
 * Created on: Dec 3, 2016
 */
package fr.bigeon.gclc.tools;

import static org.junit.Assert.assertEquals;

import java.io.IOException;

import org.junit.Test;

import fr.bigeon.gclc.manager.PipedConsoleManager;

/** <p>
 * TODO
 *
 * @author Emmanuel Bigeon */
public class AOutputForwardRunnableTest {

    /** <p>
     * TODO
     *
     * @author Emmanuel Bigeon */
    private final class AOutputForwardTestRunnable
            extends AOutputForwardRunnable {
        private int count = 1;
        private String message;

        /** @param manager */
        private AOutputForwardTestRunnable(PipedConsoleManager manager) {
            super(manager);
        }

        @Override
        protected boolean isRunning() {
            return count != 0;
        }

        @Override
        protected void forwardLine(String m) {
            // Do nothing
            message = m;
            synchronized (this) {
                notify();
                try {
                    wait();
                } catch (InterruptedException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }

        /** @return the message */
        public String getMessage() {
            if (message == null) {
                synchronized (this) {
                    try {
                        wait();
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                }
            }
            String m = message;
            count--;
            message = null;
            synchronized (this) {
                notify();
            }
            return m;
        }
    }

    /** Test method for
     * {@link fr.bigeon.gclc.tools.AOutputForwardRunnable#run()}. */
    @Test
    public final void testRun() {
        try (PipedConsoleManager manager = new PipedConsoleManager()) {
            AOutputForwardTestRunnable runnable = new AOutputForwardTestRunnable(
                    manager);

            Thread th = new Thread(runnable, "forward");
            th.start();
            manager.println("before");

            assertEquals("before", runnable.getMessage());

            th.join();

        } catch (IOException | InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
